$(document).ready(function() {
    // Event delegation for monthly view and navigation links
    $(document).on('click', '.view-switcher a, .calendar-navigation a, .day-number', function(event) {
        event.preventDefault();
        const url = $(this).attr('href');
        loadCalendar(url);
    });

    function loadCalendar(url) {
        toggleLoading(true);

        $('#container-calendar').load(`${url} #container-calendar > *`, function(response, status, xhr) {
            toggleLoading(false);

            if (status === "error") {
                displayError(xhr.status, xhr.statusText);
            } else {
                updateActiveLink(url);
            }
        });
    }

    // Toggles loading indicator visibility
    function toggleLoading(isLoading) {
        $('#loading').toggle(isLoading);
    }

    // Handles errors during calendar load
    function displayError(status, statusText) {
        $('#container-calendar').html(`Sorry, an error occurred : ${status} ${statusText}`);
    }

    // Updates active link state
    function updateActiveLink(url) {
        $('.view-switcher a, .calendar-navigation a, .day-number').removeClass('active');
        $(`a[href="${url}"]`).addClass('active');
    }
});
